#ifndef DEFINITION_H
#define DEFINITION_H
/***************************************************************************
                          definition.h  -  description
                             -------------------
    begin                : Mon Dec 23 2002
    copyright            : (C) 2002 by Andre Stein
    email                : andre_stein@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

const int FIELD_X = 11;
const int FIELD_Y = 22;

const float CYLINDER_RADIUS = 0.50f;
const float DEFAULT_SPEED = 0.1f;
const int REACTION_TIME = 350;
const int FAST_REACTION_TIME = 25;
const int PERLEVEL_TIME_DECREASE = 50;

//font width
const float FONT_SIZE = 10.0f;

//menu
const float START_X = 300.0f;
const float START_Y = 250.0f;

//configurations files

#ifdef WIN32
        #define HIGHSCORE_FILENAME "highscore.lst"
        #define CONFIG_FILENAME "game.cfg"
#else
        #define CONFIG_DIR_CMD "mkdir ~/.christmas2002"
        #define HIGHSCORE_FILENAME "highscore.lst"
        #define CONFIG_FILENAME "game.cfg"
#endif 

#define BRICK_NUM 7

enum SBrickType
{
        BRICK1 = 0,
        BRICK2,
        BRICK3,
        BRICK4,
        BRICK5,
        BRICK6,
        BRICK7
};

enum SDirection
{
        LEFT,
        RIGHT,
        BOTTOM
};

enum SGameState
{
        STATE_LOGO = 0,
        STATE_PRESENTS,
        STATE_INTRO,
        STATE_MENU,
        STATE_CREDITS,
        STATE_HIGHSCORES,
        STATE_GAME,
        STATE_END,
        STATE_NOHIGHSCORE,
        STATE_INPUT, //while in name input mode
        STATE_OPTIONS //special options state
};

//man length in highscore list
#define MAX_NAME_LENGTH 20
#define HIGHSCORE_ENTRIES 10

//Position of input dialog (title, upper most part)
const float INPUT_Y = 300.0f;

/* Credits screen */
#define CREDITS_ROLL_SPEED 0.5f
#define CREDITS_MAX_HEIGHT 800.0f


#endif