/***************************************************************************
                          sbrick.h  -  description
                             -------------------
    begin                : Sun Dec 22 2002
    copyright            : (C) 2002 by Andre Stein
    email                : andre_stein@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SBRICK_H
#define SBRICK_H

#include "sbox.h"
#include "definition.h"

/**
  *@author Andre Stein
  */

class SBrick
{
public: 
	SBrick();
	~SBrick();
        
        void create(SBrickType brickType, SBMPTexture* textures);
        const SBox* getBoxes() const { return boxes; }
        void moveBy(float x, float y);
        
        void draw();
        void moveDown();
        void moveRight();
        void moveLeft();
        bool touchesBoxes(SDirection pos);
        bool touchesBottom();
        void changeForm();
protected:
        SBrickType brick;
        SBox boxes[4];
        float rotation;
};

#endif
