/***************************************************************************
                          sendscene.cpp  -  description
                             -------------------
    begin                : Sun Dec 22 2002
    copyright            : (C) 2002 by Andre Stein
    email                : andre_stein@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "sendscene.h"

const float LEFT_SCROLL_SPEED = 0.001f;
const float MC_X_SIZE = 8.0f;
const float MC_Y_SIZE = 2.0f;
const float ROLL_X_SIZE = 4.0f;
const float ROLL_Y_SIZE = 1.0f;
const float ROLL_SPEED = 0.005f;

SEndScene::SEndScene()
{
        leftScrollPosition = MC_X_SIZE;
        roll = 0.0f;
}

SEndScene::~SEndScene()
{
}

/** No descriptions */
void SEndScene::init()
{
        texture.createTexture("data/merry_christmas.bmp");
}

/** No descriptions */
void SEndScene::update(float frametime)
{
        /** do position updates **/
        leftScrollPosition -= frametime * LEFT_SCROLL_SPEED;
        roll += frametime * ROLL_SPEED;        

        //draw!
        draw();
}

/** No descriptions */
void SEndScene::isFinished()
{
}

/** No descriptions */
void SEndScene::draw()
{
        /* MERRY CHRISTMAS ROLLer */

        glPushMatrix();

        glEnable(GL_BLEND);

        glTranslatef(-2.25f,7.0f,-10.0f);

        glBegin(GL_QUADS);
                glColor4f(1.0f,0.0f,0.0f,0.0f);
                glTexCoord2f(0.0f,roll); glVertex2f(-ROLL_X_SIZE,-12*ROLL_Y_SIZE);
                glTexCoord2f(1.0f,roll); glVertex2f(ROLL_X_SIZE,-12*ROLL_Y_SIZE);
                glColor4f(1.0f,0.0f,0.0f,1.0f);
                glTexCoord2f(1.0f,12*ROLL_Y_SIZE+roll); glVertex2f(ROLL_X_SIZE,0.0f);
                glTexCoord2f(0.0f,12*ROLL_Y_SIZE+roll); glVertex2f(-ROLL_X_SIZE,0.0f);
        glEnd();

        glDisable(GL_BLEND);

        glPopMatrix();

        /* LEFT SCROLL MC */

        glPushMatrix();

        glBlendFunc(GL_ONE,GL_ONE);
        glEnable(GL_BLEND);
        glDisable(GL_DEPTH_TEST);

        glTranslatef(leftScrollPosition,0.0f,0.0f);

        texture.select();
        
        glBegin(GL_QUADS);
                glColor3f(1.0f,1.0f,1.0f);
                glTexCoord2f(0.0f,0.0f); glVertex2f(-MC_X_SIZE,-MC_Y_SIZE);
                glTexCoord2f(1.0f,0.0f); glVertex2f(MC_X_SIZE,-MC_Y_SIZE);
                glTexCoord2f(1.0f,1.0f); glVertex2f(MC_X_SIZE,MC_Y_SIZE);
                glTexCoord2f(0.0f,1.0f); glVertex2f(-MC_X_SIZE,MC_Y_SIZE);
        glEnd();

        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);       
        glDisable(GL_BLEND);
        glEnable(GL_DEPTH_TEST);   

        glPopMatrix();       
}
