/***************************************************************************
                          shighscorelist.h  -  description
                             -------------------
    begin                : Fri Dec 27 2002
    copyright            : (C) 2002 by Andre Stein
    email                : andre_stein@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SHIGHSCORELIST_H
#define SHIGHSCORELIST_H

#include "definition.h"
#include "sbmpfont.h"

/**
  *@author Andre Stein
  */

struct SHCEntry
{
        SHCEntry()
        {
                strcpy(name,"stone");
                score = 100;
        }

        char name[MAX_NAME_LENGTH];
        unsigned int score;
};

class SHighscoreList
{
public: 
	SHighscoreList();
	~SHighscoreList();

        void init(SBMPFont* bmpFont) { font = bmpFont; }
        void save(const char* filename);
        void load(const char* filename);
        int isHighscore(unsigned int score);
        void addHighscore(const char* name, unsigned int score);
        void draw(int score);
protected:
        SHCEntry entries[HIGHSCORE_ENTRIES];
        SBMPFont* font;
};

#endif

