/***************************************************************************
                          sinputdialog.cpp  -  description
                             -------------------
    begin                : Fri Dec 27 2002
    copyright            : (C) 2002 by Andre Stein
    email                : andre_stein@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "sinputdialog.h"
#include "definition.h"
#include <string.h> 

SInputDialog::SInputDialog()
{
        string = 0;
        size = 0;
        position = 0;
        font = 0;
}

SInputDialog::~SInputDialog()
{
        if (string)
        {
                delete[] string;
                delete[] title;
        }
}

/** No descriptions */
void SInputDialog::create(int maxSize, const char* titleString)
{
        if (string)
        {
                delete[] string;
                delete[] title;
        }

        size = maxSize;
        string = new char[size];
        string[0] = '\0';
        title = new char[strlen(titleString)];
        strcpy(title, titleString);
        position = 0;
}
/** No descriptions */
void SInputDialog::keyEvent(char c)
{
        if (position < size-1)
        {
                string[position] = c;
                string[position+1] = '\0';
                position++;
        }
}

/** No descriptions */
void SInputDialog::draw()
{
        //construct title position:
        float titleX = 280.0f-strlen(title)*10/2;

        /**
          print title
         **/
        glColor3f(1.0f,0.0f,0.0f);
        font->printAt(titleX, INPUT_Y, title);
      
        /**
          print input
         **/
        glColor3f(1.0f,1.0f,1.0f);

        //first print current string
        font->printAt(titleX+50.0f, INPUT_Y-20.0f,string);
        //then print cursor, represented as '_'
        font->printAt(titleX+50.0f+strlen(string)*FONT_SIZE, INPUT_Y-20.0f,"_");
}
/** No descriptions */
void SInputDialog::backspace()
{
        //Delete last char
        position -= 1;
        if (position < 0)
                position = 0;
                
        string[position] = '\0';
}
