// SSnowflakes.cpp: Implementierung der Klasse SSnowflakes.
//
//////////////////////////////////////////////////////////////////////

#include "ssnowflakes.h"
#include <stdlib.h>

#define MAX_X_VALUE 30
#define MAX_Y_VALUE 60
#define MAX_Z_VALUE 50

#define MIN_Y_VALUE -30.0f

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

SSnowflakes::SSnowflakes()
{
	snowFlakes = new SnowFlake[MAX_SNOWFLAKES];
}

SSnowflakes::~SSnowflakes()
{
	delete[] snowFlakes;
}

void SSnowflakes::create()
{
        /** Create init set of snowflakes **/
	for (int i = 0; i < MAX_SNOWFLAKES; i += 1)
	{
		snowFlakes[i].position[0] = float(rand() % MAX_X_VALUE*10)/10.0f - float(rand() % MAX_X_VALUE*10)/10.0f;
		snowFlakes[i].position[1] = float(rand() % MAX_Y_VALUE*10)/10.0f-20.0f;
		snowFlakes[i].position[2] = -float(rand() % MAX_Z_VALUE*10)/10.0f;

		snowFlakes[i].rotation[0] = float(rand() % 360);
		snowFlakes[i].rotation[1] = float(rand() % 360);
		snowFlakes[i].rotation[2] = float(rand() % 360);

		snowFlakes[i].speed = float((rand() % 5) +1)/100;
	}

}

void SSnowflakes::update(float frametime)
{
        glBlendFunc(GL_ONE,GL_ONE);
        glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
        
	texture.select();

	for (int i = 0; i < MAX_SNOWFLAKES; i += 1)
	{
		SnowFlake& thisOne = snowFlakes[i];

		glPushMatrix();

		glTranslatef(thisOne.position[0],
			thisOne.position[1],
			thisOne.position[2]);

		glRotatef(thisOne.rotation[0],1.0,0.0,0.0);
		glRotatef(thisOne.rotation[1],0.0,1.0,0.0);
		glRotatef(thisOne.rotation[2],0.0,0.0,1.0);

        	//call object list
                glCallList(object);
		
		thisOne.position[1] -= thisOne.speed*frametime;

		thisOne.rotation[0] += 0.10f*frametime;
		thisOne.rotation[1] += 0.10f*frametime;
		thisOne.rotation[2] += 0.10f*frametime;

		if (thisOne.position[1] <= MIN_Y_VALUE)
		{
			thisOne.position[0] = float(rand() % MAX_X_VALUE*10)/10 - float(rand() % MAX_X_VALUE*10)/10;
			thisOne.position[1] = MAX_Y_VALUE;
			thisOne.position[2] = -float(rand() % MAX_Z_VALUE*10)/10;

			thisOne.rotation[0] = float(rand() % 360);
			thisOne.rotation[1] = float(rand() % 360);
			thisOne.rotation[2] = float(rand() % 360);

			thisOne.speed = float((rand() % 10) +1)/100.0f;
		}

		glPopMatrix();
	}

        //un-do changes
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glDisable(GL_BLEND);
        glEnable(GL_DEPTH_TEST);
}

/** No descriptions */
void SSnowflakes::init()
{
        texture.createMipmap("data/snowflake.bmp");

        /** Create compiled snowflake object **/

        object = glGenLists(1);

        glNewList(object, GL_COMPILE);
                glBegin(GL_QUADS);
			glColor3f(1.0,1.0,1.0);
			glTexCoord2f(0.0,1.0); glVertex3f(-0.5,0.5,0.0);
			glTexCoord2f(1.0,1.0); glVertex3f(0.5,0.5,0.0);
			glTexCoord2f(1.0,0.0); glVertex3f(0.5,-0.5,0.0);
			glTexCoord2f(0.0,0.0); glVertex3f(-0.5,-0.5,0.0);
		glEnd();
        glEndList();
}
